From bc047bb26ea082d9788440ad6ab2ca6983222081 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 27 2020 22:30:18 +0000
Subject: [PATCH 1590/2232] Add helper for querying derived traits


---

diff --git a/macro/src/derive.rs b/macro/src/derive.rs
index 87f8ec5..2109a1f 100644
--- a/macro/src/derive.rs
+++ b/macro/src/derive.rs
@@ -1,4 +1,4 @@
-use crate::syntax::{Enum, Struct, Trait};
+use crate::syntax::{derive, Enum, Struct, Trait};
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{quote, quote_spanned, ToTokens};
 
@@ -59,12 +59,7 @@ fn struct_copy(strct: &Struct, span: Span) -> TokenStream {
 fn struct_clone(strct: &Struct, span: Span) -> TokenStream {
     let ident = &strct.name.rust;
 
-    let is_copy = strct
-        .derives
-        .iter()
-        .any(|derive| derive.what == Trait::Copy);
-
-    let body = if is_copy {
+    let body = if derive::contains(&strct.derives, Trait::Copy) {
         quote!(*self)
     } else {
         let fields = strct.fields.iter().map(|field| &field.ident);
diff --git a/syntax/derive.rs b/syntax/derive.rs
index 75fc6b1..4522e68 100644
--- a/syntax/derive.rs
+++ b/syntax/derive.rs
@@ -31,3 +31,7 @@ impl PartialEq<Trait> for Derive {
         self.what == *other
     }
 }
+
+pub fn contains(derives: &[Derive], query: Trait) -> bool {
+    derives.iter().any(|derive| derive.what == query)
+}
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 744963b..bd7efc0 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -3,7 +3,7 @@
 pub mod atom;
 mod attrs;
 pub mod check;
-mod derive;
+pub mod derive;
 mod discriminant;
 mod doc;
 pub mod error;
diff --git a/syntax/types.rs b/syntax/types.rs
index 5fe63ff..c98fe85 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -3,8 +3,8 @@ use crate::syntax::improper::ImproperCtype;
 use crate::syntax::report::Errors;
 use crate::syntax::set::{OrderedSet as Set, UnorderedSet};
 use crate::syntax::{
-    toposort, Api, Enum, ExternFn, ExternType, Impl, Pair, ResolvableName, Struct, Trait, Type,
-    TypeAlias,
+    derive, toposort, Api, Enum, ExternFn, ExternType, Impl, Pair, ResolvableName, Struct, Trait,
+    Type, TypeAlias,
 };
 use proc_macro2::Ident;
 use quote::ToTokens;
@@ -260,12 +260,7 @@ impl<'a> Types<'a> {
     }
 
     pub fn is_pod(&self, strct: &Struct) -> bool {
-        for derive in &strct.derives {
-            if derive.what == Trait::Copy {
-                return true;
-            }
-        }
-        false
+        derive::contains(&strct.derives, Trait::Copy)
     }
 
     // Types that trigger rustc's default #[warn(improper_ctypes)] lint, even if

